/*********************************************************************************
Licence for Tibw - Tibetan printing software

Copyright (c) 1985-2012 Edward Henning

Permission is hereby granted, free of charge, to any person  obtaining a copy of
this software and associated documentation files (the "Software"), to deal in the
Software without restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
Software, and to permit persons to whom the Software is furnished to do so, subject
to the following conditions:

The above copyright notice and this permission notice shall be included in all copies
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
************************************************************************************/
//#define INCLUDE_DRIVINIT_H
#define INCLUDE_COMMDLG_H       1
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>
#include <string.h>
#include <malloc.h>
#include <strsafe.h>
#include "tibw.h"
#include "tform.h"
#include "tibform.ext"

void DrawBitmapXY ( HDC, HBITMAP, int, int );

extern char *tf37buf;
extern int tf37_xpt, tf37_ypt, tf37_fc, tf37_lc;
extern HBITMAP tf37_hbm[94];

extern char *tf38buf;
extern int tf38_xpt, tf38_ypt, tf38_fc, tf38_lc;
extern HBITMAP tf38_hbm[60];

extern char *tf39buf;
extern int tf39_xpt, tf39_ypt, tf39_fc, tf39_lc;
extern HBITMAP tf39_hbm[94];

extern char *tf40buf;
extern int tf40_xpt, tf40_ypt, tf40_fc, tf40_lc;
extern HBITMAP tf40_hbm[60];

extern char *tf41buf;
extern int tf41_xpt, tf41_ypt, tf41_fc, tf41_lc;
extern HBITMAP tf41_hbm[94];

extern char *tf42buf;
extern int tf42_xpt, tf42_ypt, tf42_fc, tf42_lc;
extern HBITMAP tf42_hbm[60];

extern PRINTDLG prstr;
extern HFONT CFont;

// Font rotation data:
int angle; 
extern LOGFONT plf;
extern HGDIOBJ hfnt, hfntPrev; 
char lpszRotate[22] = "  Test rotation...";
extern HRESULT hr; 
extern int pcch;

void TestP01 ( void )
  {
    int i;
    HGDIOBJ fres;
    SIZE        sz; // For font data
    txtrct.left = 200; // These are old HP Laserjet values
    txtrct.right = 2200;
    txtrct.top = 20; 
    txtrct.bottom = 3300; 
    open_portrait_tfonts (); 
    portprn = 255;
    Escape( prstr.hDC, STARTDOC, 4, NULL, NULL );  
    set_print_font ( prstr.hDC ); // Sets for Courier New.            
    pcur_x = 350;
    pcur_y = 350;
    CFont = GetStockObject ( DEVICE_DEFAULT_FONT );
    if ( CFont == NULL )
      Msg ( "Font get failed..." );
    fres = SelectObject ( prstr.hDC, CFont );            
    if ( fres == NULL )
      {
        Msg ("Font selection failed...");
      }
    GetTextExtentPoint( prstr.hDC, "MM", 2, &sz );
    sprintf ( d_bugstr, "Lineheight = %d, width = %d\n", sz.cy, sz.cx/2 );
    wrt_debug ();
    pcur_y = pcur_y + 100;
    sprintf ( d_bugstr, "Width = %d mms", pr_horzsize );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );     
    pcur_y = pcur_y + 100;
    sprintf ( d_bugstr, "Height = %d mms", pr_vertsize );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );                     
    pcur_y = pcur_y + 100;
    sprintf ( d_bugstr, "Width = %d pixels", pr_horzres );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );         
    pcur_y = pcur_y + 100;
    sprintf ( d_bugstr, "Height = %d pixels", pr_vertres );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );         
    pcur_y = pcur_y + 100;
    sprintf ( d_bugstr, "X, pixels per inch = %d", pr_logpixelsx );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );         
    pcur_y = pcur_y + 100;
    sprintf ( d_bugstr, "Y, pixels per inch = %d", pr_logpixelsy );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );         
    pcur_y = pcur_y + 100;
    sprintf ( d_bugstr, "Bits per pixel = %d", pr_bitspixel );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );         
    pcur_y = pcur_y + 100;
    sprintf ( d_bugstr, "X, Physical width = %d", pr_physicalwidth );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );         
    pcur_y = pcur_y + 100;
    sprintf ( d_bugstr, "X, Physical height = %d", pr_physicalheight );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );         
    pcur_y = pcur_y + 100;    
    sprintf ( d_bugstr, "X, Physical offset X = %d", pr_physicaloffsetx );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );         
    pcur_y = pcur_y + 100;    
    sprintf ( d_bugstr, "X, Physical offset Y = %d", pr_physicaloffsety );
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );     
    pcur_y = pcur_y + 100;    
    sprintf ( d_bugstr, "Lineheight = %d, width = %d\n", sz.cy, sz.cx/2 );    
    TextOut( prstr.hDC, pcur_x, pcur_y, d_bugstr, strlen (d_bugstr) );     
    pcur_x = 350;
    pcur_y = pcur_y / 2 + 100;
    setcurpos ( pcur_x, pcur_y );
    cur_fnt = 37;
    for ( i = 0; i < 31; ++i )
      {  
        DrawBitmapXY ( prstr.hDC, tf37_hbm[i], dev_cur_x, dev_cur_y );        
        pcur_x = pcur_x + 50;
        setcurpos ( pcur_x, pcur_y );            
      }
    pcur_x = 350;
    pcur_y = pcur_y + 120;
    setcurpos ( pcur_x, pcur_y );
    for ( i = 31; i < 62; ++i )
      {  
        DrawBitmapXY ( prstr.hDC, tf37_hbm[i], dev_cur_x, dev_cur_y );        
            pcur_x = pcur_x + 50;
            setcurpos ( pcur_x, pcur_y );            
      }
    pcur_x = 350;
    pcur_y = pcur_y + 120;
    setcurpos ( pcur_x, pcur_y );
    for ( i = 62; i < 94; ++i )
      {  
        DrawBitmapXY ( prstr.hDC, tf37_hbm[i], dev_cur_x, dev_cur_y );        
        pcur_x = pcur_x + 50;
        setcurpos ( pcur_x, pcur_y );            
      }          
    pcur_x = 350;
    pcur_y = pcur_y + 120;
    setcurpos ( pcur_x, pcur_y );
    for ( i = 0; i < 30; ++i )
      {  
        DrawBitmapXY ( prstr.hDC, tf38_hbm[i], dev_cur_x, dev_cur_y );        
        pcur_x = pcur_x + 50;
        setcurpos ( pcur_x, pcur_y );            
      }
    pcur_x = 350;
    pcur_y = pcur_y + 120;
    setcurpos ( pcur_x, pcur_y );
    for ( i = 30; i < 60; ++i )
      {  
        DrawBitmapXY ( prstr.hDC, tf38_hbm[i], dev_cur_x, dev_cur_y );        
        pcur_x = pcur_x + 50;
        setcurpos ( pcur_x, pcur_y );            
      }          
    cur_fnt = 37;
    pcur_y = pcur_y + 400;
    pcur_x = 800;
    sprintf ( d_bugstr, "1: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    hor_lin ( pcur_x, pcur_y, pcur_x + 500, 3 );
    sprintf ( d_bugstr, "2: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    hor_lin ( pcur_x, pcur_y + 500, pcur_x + 500, 3 );  
    sprintf ( d_bugstr, "3: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();    
    ver_lin ( pcur_y, pcur_y + 500, pcur_x, 3 );
    sprintf ( d_bugstr, "4: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    ver_lin ( pcur_y, pcur_y + 500, pcur_x + 500, 3 );
    sprintf ( d_bugstr, "5: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    setcurpos ( pcur_x, pcur_y );
    lp_chr ( 74 );
    lp_chr ( 71 );
    cur_fnt = 38;
    lp_chr ( 85 );
    cur_fnt = 37;
    setcurpos ( pcur_x, pcur_y + 500 );
    lp_chr ( 74 );
    lp_chr ( 71 );
    cur_fnt = 38;
    lp_chr ( 85 );
    cur_fnt = 37;
    setcurpos ( pcur_x + 500, pcur_y );
    lp_chr ( 74 );
    lp_chr ( 73 );
    setcurpos ( pcur_x + 500, pcur_y + 500 );
    lp_chr ( 74 );
    lp_chr ( 73 );    
    MoveToEx ( prstr.hDC, 0, 0, NULL );
    LineTo ( prstr.hDC, pr_horzres - 1, 0 );
    LineTo ( prstr.hDC, pr_horzres - 1, pr_vertres - 1 );    
    LineTo ( prstr.hDC, 0, pr_vertres - 1 );        
    LineTo ( prstr.hDC, 0, 0 );                
     for ( pcur_x = 250; pcur_x < pr_horzres; pcur_x = pcur_x + 250 )
       {
          MoveToEx ( prstr.hDC, pcur_x, 0, NULL );
          LineTo ( prstr.hDC, pcur_x, pcur_x/5 );
       }
    Escape ( prstr.hDC, ENDDOC, 0, NULL, NULL );
    clean_portrait ();             
  } // END - TestP01

void TestL02 ( void )
// Remember to include the error checking in SCRIBE32. That is ignored here.
  {
    int x, y, i;
    open_landscape_tfonts ();
    Escape( prstr.hDC, STARTDOC, 4, NULL, /*"Test",*/ NULL );  
    MoveToEx ( prstr.hDC, 0, 0, NULL );
    LineTo ( prstr.hDC, pr_horzres - 1, 0 );
    LineTo ( prstr.hDC, pr_horzres - 1, pr_vertres - 1 );    
    LineTo ( prstr.hDC, 0, pr_vertres - 1 );        
    LineTo ( prstr.hDC, 0, 0 );       
    x = 400;
    y = pr_vertres - 400;
    for ( i = 0; i < 47; ++i )
      {
        DrawBitmapXY ( prstr.hDC, tf37_hbm[i], x, y );              
        y = y - 110;
      }
    x = 800;
    y = pr_vertres - 400;
    for ( i = 47; i < 94; ++i )
      {
        DrawBitmapXY ( prstr.hDC, tf37_hbm[i], x, y );              
        y = y - 110;
      }    
    x = 1200;
    y = pr_vertres - 400;
    for ( i = 0; i < 60; ++i )
      {
        DrawBitmapXY ( prstr.hDC, tf38_hbm[i], x, y );              
        y = y - 100;
      }          
    x = 1600;
    y = pr_vertres - 400;
    for ( i = 0; i < 47; ++i )
      {
        DrawBitmapXY ( prstr.hDC, tf39_hbm[i], x, y );              
        y = y - 110;
      }
    x = 2000;
    y = pr_vertres - 400;
    for ( i = 47; i < 94; ++i )
      {
        DrawBitmapXY ( prstr.hDC, tf39_hbm[i], x, y );              
        y = y - 110;
      }    
    x = 2400;
    y = pr_vertres - 400;
    for ( i = 0; i < 60; ++i )
      {
        DrawBitmapXY ( prstr.hDC, tf40_hbm[i], x, y );              
        y = y - 100;
      }        
    x = 2800;
    y = pr_vertres - 400;
    for ( i = 0; i < 47; ++i )
      {
        DrawBitmapXY ( prstr.hDC, tf41_hbm[i], x, y );              
        y = y - 110;
      }
    x = 3200;
    y = pr_vertres - 400;
    for ( i = 47; i < 94; ++i )
      {
        DrawBitmapXY ( prstr.hDC, tf41_hbm[i], x, y );              
        y = y - 110;
      }    
    x = 3600;
    y = pr_vertres - 400;
    for ( i = 0; i < 60; ++i )
      {
        DrawBitmapXY ( prstr.hDC, tf42_hbm[i], x, y );              
        y = y - 100;
      }        
    Escape ( prstr.hDC, NEWFRAME, 0, NULL, NULL );            
    Escape ( prstr.hDC, ENDDOC, 0, NULL, NULL );
    clean_landscape ();             
  } // END - TestL02  
  
void TestL01 ( void )
  {
    int tgt_dev_x, tgt_dev_y;
    open_landscape_tfonts ();
    Escape( prstr.hDC, STARTDOC, 4, NULL, /*"Test",*/ NULL );  
    MoveToEx ( prstr.hDC, 0, 0, NULL );
    LineTo ( prstr.hDC, pr_horzres - 1, 0 );
    LineTo ( prstr.hDC, pr_horzres - 1, pr_vertres - 1 );    
    LineTo ( prstr.hDC, 0, pr_vertres - 1 );        
    LineTo ( prstr.hDC, 0, 0 );       
    tgt_dev_x = 800;
    tgt_dev_y = 1000;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf37_hbm[41], dev_cur_x, dev_cur_y );        
    DrawBitmapXY ( prstr.hDC, tf37_hbm[40], dev_cur_x, dev_cur_y );    
    tgt_dev_x = 800;
    tgt_dev_y = 1500;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf37_hbm[41], dev_cur_x, dev_cur_y );        
    DrawBitmapXY ( prstr.hDC, tf37_hbm[40], dev_cur_x, dev_cur_y );        
    tgt_dev_x = 800;
    tgt_dev_y = 2000;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf38_hbm[9], dev_cur_x, dev_cur_y );        
    tgt_dev_x = 800;
    tgt_dev_y = 2500;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf38_hbm[10], dev_cur_x, dev_cur_y );        
    tgt_dev_x = 1500;
    tgt_dev_y = 1000;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf39_hbm[41], dev_cur_x, dev_cur_y );        
    DrawBitmapXY ( prstr.hDC, tf39_hbm[40], dev_cur_x, dev_cur_y );    
    tgt_dev_x = 1500;
    tgt_dev_y = 1500;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf39_hbm[41], dev_cur_x, dev_cur_y );        
    DrawBitmapXY ( prstr.hDC, tf39_hbm[40], dev_cur_x, dev_cur_y );        
    tgt_dev_x = 1500;
    tgt_dev_y = 2000;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf40_hbm[9], dev_cur_x, dev_cur_y );        
    tgt_dev_x = 1500;
    tgt_dev_y = 2500;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf40_hbm[10], dev_cur_x, dev_cur_y );        
    tgt_dev_x = 800;
    tgt_dev_y = 3000;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf41_hbm[41], dev_cur_x, dev_cur_y );        
    DrawBitmapXY ( prstr.hDC, tf41_hbm[40], dev_cur_x, dev_cur_y );    
    tgt_dev_x = 1500;
    tgt_dev_y = 3000;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf41_hbm[41], dev_cur_x, dev_cur_y );        
    DrawBitmapXY ( prstr.hDC, tf41_hbm[40], dev_cur_x, dev_cur_y );        
    tgt_dev_x = 800;
    tgt_dev_y = 3500;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf42_hbm[10], dev_cur_x, dev_cur_y );    
    tgt_dev_x = 1500;
    tgt_dev_y = 3500;
    MoveToEx ( prstr.hDC, tgt_dev_x - 300, tgt_dev_y, NULL );
    LineTo ( prstr.hDC, tgt_dev_x + 300, tgt_dev_y );
    MoveToEx ( prstr.hDC, tgt_dev_x, tgt_dev_y - 300, NULL );
    LineTo ( prstr.hDC, tgt_dev_x, tgt_dev_y + 300 );
    dev_cur_x = tgt_dev_x;
    dev_cur_y = tgt_dev_y;
    DrawBitmapXY ( prstr.hDC, tf42_hbm[10], dev_cur_x, dev_cur_y );        
    cur_fnt = 37;
    pcur_y = 500;
    pcur_x = 200;
    sprintf ( d_bugstr, "1: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    hor_lin ( pcur_x, pcur_y, pcur_x + 500, 3 );
    sprintf ( d_bugstr, "2: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    hor_lin ( pcur_x, pcur_y + 500, pcur_x + 500, 3 );  
    sprintf ( d_bugstr, "3: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();    
    ver_lin ( pcur_y, pcur_y + 500, pcur_x, 3 );
    sprintf ( d_bugstr, "4: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    ver_lin ( pcur_y, pcur_y + 500, pcur_x + 500, 3 );
    sprintf ( d_bugstr, "5: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    setcurpos ( pcur_x, pcur_y );
    lp_chr ( 74 );
    lp_chr ( 73 );    
    setcurpos ( pcur_x, pcur_y + 500 );
    lp_chr ( 74 );
    lp_chr ( 73 );    
    setcurpos ( pcur_x + 500, pcur_y );
    lp_chr ( 74 );
    lp_chr ( 73 );        
    setcurpos ( pcur_x + 500, pcur_y + 500 );
    lp_chr ( 74 );    
    lp_chr ( 73 );        
    pcur_y = 1500;
    pcur_x = 200;
    cur_fnt = 39;
    smlfnt = 1;
    sprintf ( d_bugstr, "1: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    hor_lin ( pcur_x, pcur_y, pcur_x + 500, 3 );
    sprintf ( d_bugstr, "2: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    hor_lin ( pcur_x, pcur_y + 500, pcur_x + 500, 3 );  
    sprintf ( d_bugstr, "3: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();    
    ver_lin ( pcur_y, pcur_y + 500, pcur_x, 3 );
    sprintf ( d_bugstr, "4: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    ver_lin ( pcur_y, pcur_y + 500, pcur_x + 500, 3 );
    sprintf ( d_bugstr, "5: X: %d, Y: %d, Dev X: %d, Dev Y: %d.", pcur_x, pcur_y, dev_cur_x, dev_cur_y );
    wrt_debug ();
    setcurpos ( pcur_x, pcur_y );
    lp_chr ( 74 );
    lp_chr ( 73 );    
    setcurpos ( pcur_x, pcur_y + 500 );
    lp_chr ( 74 );
    lp_chr ( 73 );    
    setcurpos ( pcur_x + 500, pcur_y );
    lp_chr ( 74 );
    lp_chr ( 73 );    
    setcurpos ( pcur_x + 500, pcur_y + 500 );
    lp_chr ( 74 );   
    lp_chr ( 73 );    
    smlfnt = 0; 
// Now, test rotating font using method from MS's "Rotating Lines of Text":
    hr = StringCchCopy ( plf.lfFaceName, 12, TEXT("Courier New"));
    if ( FAILED (hr) )
      {
        hr = StringCchCopy ( plf.lfFaceName, 12, TEXT("Courier"));      
        if ( FAILED (hr) )
          {
            sprintf ( d_bugstr, "Major problem: could not access font for pages numbers!" );
            Msg (d_bugstr);
            wrt_debug ();
          }  
      }
    plf.lfWeight = FW_NORMAL; 
    SetBkMode(prstr.hDC, TRANSPARENT); 
// Draw the string 10 times, rotating 36 degrees 
// counter-clockwise each time. 
    for ( angle = 0; angle < 3600; angle += 360 ) 
      { 
        plf.lfEscapement = angle; 
        hfnt = CreateFontIndirect( &plf ); 
        hfntPrev = SelectObject( prstr.hDC, hfnt );
        pcch = strlen (lpszRotate);
        if (FAILED(hr))
          {
            ;// TODO: write error handler
          } 
// BOOL TextOut( HDC hdc, int nXStart, int nYStart, LPCTSTR lpString, int cchString );
        pcur_x = logicy_max*2/3; // Reversed, because default is portrait mode
        pcur_y = logicx_max*2/3;
        hor_lin ( pcur_x-500, pcur_y, pcur_x+500, 1 );
        ver_lin ( pcur_y-500, pcur_y+500, pcur_x, 1 );
        setcurpos ( logicy_max*2/3, logicx_max*2/3 ); 
        TextOut ( prstr.hDC, dev_cur_x, dev_cur_y, lpszRotate, pcch ); 
        SelectObject( prstr.hDC, hfntPrev); 
        DeleteObject( hfnt); 
      } 
    SetBkMode( prstr.hDC, OPAQUE ); 
    Escape ( prstr.hDC, NEWFRAME, 0, NULL, NULL );            
    Escape ( prstr.hDC, ENDDOC, 0, NULL, NULL );
    clean_landscape ();             
  } // END - TestL01
  